program main
use appgraphics
implicit none

    integer::myscreen
    integer::calcbutton
    
    integer, parameter::lowest = 1
    integer, parameter::highest = 69
    integer, parameter::length = 5
    
    interface
        subroutine init_lucky_numbers
        end subroutine init_lucky_numbers
    end interface
    
    call init_lucky_numbers()
    
    myscreen = initwindow(400, 200, closeflag=.TRUE.)
    call settextstyle(BOLD_SERIF_FONT, HORIZ_DIR, 24)
    
    calcbutton = createbutton(150, 125, 100, 40, "Generate", calculate)
    
    call loop()
    
    call closewindow(myscreen)

contains

    subroutine calculate()
    use appgraphics
    implicit none
    
    interface
        subroutine lucky_numbers(v, l, h)
        integer, dimension(:), intent(inout)::v
        integer, intent(in)::l, h
        end subroutine lucky_numbers
    end interface
    
    integer, dimension(length)::values
    integer::i, x
    character(len=4)::number_text
    
        call clearviewport()
    
        call lucky_numbers(values, lowest, highest)
        
        x = 20
        do i=1, length
            write(number_text, '(I3)') values(i)
            call outtextxy(x, 30, trim(number_text))
            x = x + (getmaxx()-60)/(length-1)
        end do
    
    end subroutine calculate

end program main
