C	  Initialize our lucky number system
      subroutine init_lucky_numbers()
      implicit none
      
          call random_seed()
          
      end subroutine init_lucky_numbers


C     Generate an array of random numbers between the two
C     specified values
      subroutine lucky_numbers(values, lowest, highest)
      implicit none
      
      integer, dimension(:), intent(inout)::values
      integer, intent(in)::lowest, highest
      integer::i, full_range
      real::random_value
      
C         Error checking
          if(highest <= lowest) then
              values = lowest
              return
          end if
          
          full_range = highest - lowest
          
C         Loop through our array
          do i=lbound(values, 1), ubound(values, 1)
              call random_number(random_value)
              
C             Scale the value to be between our numbers of interest
              random_value = random_value*real(full_range) + 
     .                       real(lowest)
     
C             Scale to the nearest integer and store it
              values(i) = nint(random_value)
              
          end do
          
      end subroutine lucky_numbers
      
              